/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package rs.fon.silab.master.nst.simpleconnectionpool.connectionpool;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import rs.fon.silab.master.nst.simpleconnectionpool.config.Configuration;

/**
 *
 * @author user
 */
public class JdbcConnectionPool {

    private final List<Connection> connectionPool;

    public JdbcConnectionPool() {
        connectionPool = new ArrayList<Connection>();
        initConnectionPool();
    }

    private void initConnectionPool() {
        while (!isFull()) {
            connectionPool.add(createConnection());
        }
    }

    private synchronized boolean isFull() {
        int MAX_POOL_SIZE = Configuration.getInstance().DB_MAX_CONNECTIONS;

        if (connectionPool.size() < MAX_POOL_SIZE) {
            return false;
        }

        return true;
    }

    private Connection createConnection() {
        Configuration config = Configuration.getInstance();
        try {
            Class.forName(config.DB_DRIVER);
            Connection connection = (Connection) DriverManager.getConnection(
                    config.DB_URL, config.DB_USER_NAME, config.DB_PASSWORD);
            return connection;
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return null;

    }

    public synchronized Connection getConnection() {
        Connection connection = null;
        if (connectionPool.size() > 0) {
            connection = (Connection) connectionPool.get(0);
            connectionPool.remove(0);
        }
        return connection;
    }

    public synchronized void returnConnection(Connection connection) {
        connectionPool.add(connection);
    }
}
